dofile_once("data/scripts/lib/utilities.lua")

local entity_id    = GetUpdatedEntityID()
local x, y = EntityGetTransform( GetUpdatedEntityID() )

local dm = 1.0

edit_component( entity_id, "HitboxComponent", function(comp,vars)
	dm = ComponentGetValue2( comp, "damage_multiplier" )
	
	if ( dm < 1.0 ) then
		dm = math.min( 1.0, dm + 0.35 )
	end
	
	ComponentSetValue2( comp, "damage_multiplier", dm )
end)

EntitySetComponentsWithTagEnabled( entity_id, "invincible", false )

local state = 0
local p = ""
local comps = EntityGetComponent( entity_id, "VariableStorageComponent" )
if ( comps ~= nil ) then
	for i,v in ipairs( comps ) do
		local n = ComponentGetValue2( v, "name" )
		if ( n == "state" ) then
			state = ComponentGetValue2( v, "value_int" )
			
			state = (state + 1) % 10
			
			ComponentSetValue2( v, "value_int", state )
		elseif ( n == "memory" ) then
			--print( ComponentGetValue2( v, "value_string" ) )
			p = ComponentGetValue2( v, "value_string" )
			
			if ( #p == 0 ) then
				p = "data/entities/projectiles/enlightened_laser_darkbeam.xml"
				ComponentSetValue2( v, "value_string", p )
			end
		end
	end
end

SetRandomSeed( x, y * GameGetFrameNum() )

local spells = {
	"acidburst",
	"acidshot",
	"acidshot_slow",
	"arrow",
	"bat",
	"bloomshot",
	"bomb",
	"bomb_cart",
	"bomb_holy",
	"cocktail",
	--"bomb_holy_giga",
	"bomb_small",
	"bossdragon",
	"bossdragon_ray",
	"buckshot",
	"bullet_poison",
	"chaos_polymorph",
	"chunk_of_soil",
	--"circle_acid_small", too laggy
	--"circle_blood_small",
	--"circle_lava_small",
	--"circle_water",
	"clusterbomb",
	"cocktail",
	"coward_bullet",
	"darkflame",
	"darkflame_stationary",
	"dotshot",
	"dotshot_strong",
	"egg_fire",
	"egg_monster",
	"egg_purple",
	"egg_red",
	"egg_slime",
	"egg_worm",
	"enlightened_laser_dark_wand",
	"enlightened_laser_elec_wand",
	"enlightened_laser_fire_wand",
	"enlightened_laser_light_wand",
	"explosion",
	"fire_trap",
	"fireball",
	"fireball_bigfirebug",
	"fireball_firebug", 
	"fireball_ghostly",
	"flamethrower",
	"freeze_circle",
	"fungus",
	"fungus_big_explosion",
	"fungus_explosion",
	"gasblob",
	"glitter_bomb",
	"glue",
	"glue_shot",
	"grenade_leader",
	"grenade_scavenger",
	"healshot",
	"healshot_safe_haven",
	"healshot_slow",
	"hiddenshot",
	"ice",
	"iceball",
	"icethrower",
	"invisshot",
	"laser_bouncy",
	"laser_lasergun",
	"laser_spear",
	"laser_turret",
	"laserbeam",
	"laserbeam_green",
	"lavashot",
	"meteor_green",
	"lightning",
	"lurkershot",
	"machinegun_bullet_roboguard_big",
	"machinegun_bullet_slow",
	"machinegun_bullet_slower",
	"machinegun_bullet_tank",
	"machinegun_bullet_tank_super",
	"megalaser_blue",
	"megalaser_blue_beam",
	"meteor_green",
	"mine",
	"mine_scavenger",
	"neutralizershot",
	"orb",
	"orb_blue",
	"orb_cursed",
	"orb_dark",
	"orb_expanding",
	"orb_green",
	"orb_green_accelerating",
	"orb_green_boss_dragon",
	"orb_green_spin",
	"orb_hearty",
	"orb_homing",
	"orb_neutral",
	"orb_pink",
	"orb_pink_big",
	"orb_pink_big_slow",
	"orb_pink_big_super",
	"orb_pink_big_super_shrapnel",
	"orb_pink_fast",
	"orb_pink_super",
	--"orb_poly",
	"orb_purple",
	"orb_swapper",
	"orb_tele",
	"orb_tiny",
	"orb_twitchy",
	"orb_weaken",
	"orb_wither",
	"orb_weaken",
	"orb_wither",
	"orbspawner",
	"orbspawner_blue",
	"orbspawner_green",
	"pebble",
	"pollen",
	"pollen_ball",
	--"polyorb",
	"present",
	"propane_tank",
	"radioactive_blob",
	"radioactive_blob_trail",
	"radioactive_liquid",
	"rain_gold",
	"remove_ground",
	"rocket_tank",
	"rocket_tiny",
	"rocket_tiny_roll",
	"sentryshot",
	"shieldshot",
	"shieldshot_small",
	"slimeblob",
	"slimetrail",
	"smalltentacle",
	"smalltentacle_melee",
	"sniperbullet",
	"soldiershot",
	"spit_trap",
	"summonshine",
	"tentacle",
	"thunder_trap",
	"thunderball",
	"thunderball_line",
	"thunderball_slow",
	"tnt",
	"wraith_glowing_laser",
	"deck/all_blackholes",
	"deck/all_deathcrosses",
	"deck/all_discs",
	--"deck/all_nukes",
	"deck/all_rockets",
	"deck/berserk_field",
	"deck/big_magic_shield_start",
	"deck/black_hole",
	"deck/black_hole_big",
	--"deck/black_hole_giga", Funny to see omega blackhole, but ultimately a bit too unfair, even for this mod
	"deck/bloodtentacle",
	"deck/bomb_detonator",
	"deck/bouncy_orb",
	"deck/bubbleshot",
	"deck/bullet",
	"deck/bullet_heavy",
	"deck/bullet_slow",
	"deck/chain_bolt",
	"deck/chainsaw",
	"deck/chaos_polymorph_field",
	"deck/charm_field",
	--"deck/cloud_acid",
	--"deck/cloud_blood",
	--"deck/cloud_water",
	"deck/crumbling_earth",
	"deck/disc_bullet",
	"deck/disc_bullet_big",
	"deck/disc_bullet_bigger",
	"deck/grenade",
	"deck/grenade_tier_2",
	"deck/grenade_tier_3",
	"deck/infestation",
	"deck/luminous_drill",
	"deck/sausage",
	--"deck/sea_acid",
	--"deck/sea_alcohol",
	"deck/sea_water",
	--"deck/sea_lava",
	"deck/spitter",
	"deck/spitter_tier_2",
	"deck/spitter_tier_3",
	"deck/swarm_wasp",
	"deck/swarm_fly",
	"deck/swarm_firebug",
	"deck/touch_gold",
	"deck/worm_shot",
	"deck/megalaser",
	"deck/light_bullet",
	"deck/spiral_shot",
	"deck/spore_pod",
}

local players = EntityGetWithTag( "player_unit" )
local player = players[1]

if ( state == 1 ) then
	if ( #p > 0 ) then
		local angle = Random( 1, 200 ) * math.pi
		local vel_x = math.cos( angle ) * 100
		local vel_y = 0 - math.cos( angle ) * 100
		
		--local spells = { "rocket", "rocket_tier_2", "rocket_tier_3", "grenade", "grenade_tier_2", "grenade_tier_3", "rubber_ball" }

		local rnd = Random( 1, #spells )
		local path = "data/entities/projectiles/" .. spells[rnd] .. ".xml"
		
		local wid = shoot_projectile( entity_id, "data/entities/animals/boss_pit/wand.xml", x, y, vel_x, vel_y )
		edit_component( wid, "VariableStorageComponent", function(comp,vars)
			ComponentSetValue2( comp, "value_string", path )
		end)
		
		EntityAddComponent( wid, "HomingComponent", 
		{ 
			homing_targeting_coeff = "30.0",
			homing_velocity_multiplier = "0.16",
			target_tag = "player_unit",
		} )
		
		if ( string.find( path, "rocket" ) ~= nil ) then
			EntityAddComponent( wid, "VariableStorageComponent", 
			{ 
				name = "mult",
				value_float = 0.5,
			} )
		else
			EntityAddComponent( wid, "VariableStorageComponent", 
			{ 
				name = "mult",
				value_float = 1.2,
			} )
		end

		local rnd = Random( 1, #spells - 1 )
		local path = "data/entities/projectiles/" .. spells[rnd] .. ".xml"
		
		local wid = shoot_projectile( entity_id, "data/entities/animals/boss_pit/wand.xml", x, y, vel_x - vel_x, vel_y - vel_y )
		edit_component( wid, "VariableStorageComponent", function(comp,vars)
			ComponentSetValue2( comp, "value_string", path )
		end)
		
		EntityAddComponent( wid, "HomingComponent", 
		{ 
			homing_targeting_coeff = "30.0",
			homing_velocity_multiplier = "0.16",
			target_tag = "player_unit",
		} )
		
		if ( string.find( path, "rocket" ) ~= nil ) then
			EntityAddComponent( wid, "VariableStorageComponent", 
			{ 
				name = "mult",
				value_float = 0.5,
			} )
		else
			EntityAddComponent( wid, "VariableStorageComponent", 
			{ 
				name = "mult",
				value_float = 1.2,
			} )
		end
	end
elseif ( state == 7 ) then
	if ( Random( 1, 10 ) == 5 ) or ( 1 == 1 ) then
		--local spells = { "orb_poly", "orb_neutral", "orb_tele", "orb_dark" }
		local rnd = Random( 1, #spells )
		local path = "data/entities/projectiles/" .. spells[rnd] .. ".xml"
		
		local arc = math.pi * 0.25
		local offset = math.pi * ( Random( 1, 10 ) * 0.1 )
		
		for i=0,7 do
			local vel_x = math.cos( arc * i + offset ) * 300
			local vel_y = 0 - math.sin( arc * i + offset ) * 300
			shoot_projectile( entity_id, path, x, y, vel_x, vel_y )
		end
	end
end