dofile("data/scripts/lib/utilities.lua")
dofile_once("mods/creature_corruption/files/scripts/pool_creator.lua")


local audioPool = {
    "animals/wizard",
    "animals/miner_fire",
    "animals/generic",
    "animals/robot",
    "animals/thunderskull",
    "animals/necromancer_shop",
    "animals/fireskull",
    "animals/worm",
    "animals/miner",
    "animals/boss_centipede",
    "animals/alchemist",
    "animals/shotgunner",
    "animals/bat",
    "animals/illusion",
    "animals/bigbat",
    "animals/statue",
    "animals/ghost",
    "animals/failed_alchemist_b_orb",
    "animals/iceskull",
    "animals/scavenger_leader",
    "animals/longleg",
    "animals/spearbot",
    "animals/blob",
    "animals/laser_lasergun",
    "animals/crystal",
    "animals/damage",
    "animals/firebug",
    "animals/maggot",
    "animals/wraith_storm",
    "animals/monk",
    "animals/bloom",
    "animals/failed_alchemst",
    "animals/firemage",
    "animals/scavenger",
    "animals/zombie",
    "animals/homunculus",
    "animals/skullfly",
    "animals/sheep",
    "animals/fungus",
    "animals/drone_lasership",
    "animals/goblin",
    "animals/slime",
    "animals/gazer",
    "animals/tank",
    "animals/necromancer",
    "animals/frog",
    "animals/slimy_big",
    "animals/lukki",
    "animals/giantshooter",
    "animals/shaman",
    "animals/lukki_tiny",
    "animals/tiny_ghost",
    "animals/pebble",
    "animals/frog_big",
    "animals/lukki_eggs",
    "animals/enlightened_alchemist",
    "animals/rat",
    "animals/spitmonster",
}

local entity_id = GetUpdatedEntityID()
--local pos_x,pos_y = EntityGetTransform(entity_id)
--local r = 600
local enemy_list = EntityGetWithTag( "mortal" )
local settingCorruption = ModSettingGet( "creature_corruption.corruption_level" )
local settingSprite = ModSettingGet( "creature_corruption.spritesheet" )
--settingCorruption = (settingCorruption * -1) + 100

for id,enemy in pairs(enemy_list) do
    local debugtest = EntityHasTag(enemy, "creature_corrupted" )
    --GamePrint("Creature has finished tag = " .. tostring(debugtest))
    if (EntityHasTag(enemy, "creature_corrupted" ) == false) and (EntityHasTag(enemy, "player_unit" ) == false) then
        local pos_x, pos_y = EntityGetTransform(enemy)
        SetRandomSeed(pos_x + pos_y, pos_x * pos_y)

        --Setting Corruption x2 chance to randomise projectile
        if (Random(1,50) <= settingCorruption) then

            --Debugging
            --GamePrint("Debug Test 1")


            --Grabs random projectile file
            local projFile = pickrandomspell( pos_x, pos_y )

            local comp = EntityGetFirstComponentIncludingDisabled( enemy, "AnimalAIComponent" )
            if comp ~= nil then
                if ComponentGetValue2( comp, "attack_ranged_entity_file" ) ~= nil then

                    ComponentSetValue2( comp, "attack_ranged_entity_file", projFile .. ".xml" )
                    if (projFile == "healshot") or (projFile == "healshot_safe_haven") or (projFile == "healshot_slow") or (projFile == "invisshot") or (projFile == "shieldshot") or (projFile == "shieldshot_small") then
                        ComponentSetValue2( comp, "tries_to_ranged_attack_friends", true )
                        ComponentSetValue2( comp, "attack_if_damaged_probability", 0 )
                        ComponentSetValue2( comp, "escape_if_damaged_probability", 100 )
                        ComponentSetValue2( comp, "attack_ranged_enabled", true )
                        --GamePrint("My status on shooting friends is true and my projectile is " .. projFile)
                    else 
                        ComponentSetValue2( comp, "tries_to_ranged_attack_friends", false )
                        ComponentSetValue2( comp, "attack_ranged_enabled", true )
                        --GamePrint("My status on shooting friends is false and my projectile is " .. projFile)
                    end

                    -- 1 in 25 creatures get 10x attack speed
                    if Random(1,25) == 1 then
                        if EntityHasTag(enemy, "miniboss") ~= true then --Prevent minibosses from attacking so fast they can't actually attack
                            local aspd = ComponentGetValue2( comp, "attack_ranged_frames_between" )
                            ComponentSetValue2( comp, "attack_ranged_frames_between", (aspd / 10))

                            --Drops 2 hearts on death as a reward
                            EntityAddComponent2(
                                enemy,
                                "LuaComponent",
                                {
                                    _tags="death_reward",
                                    script_death="mods/creature_corruption/files/scripts/animals/centipede_death.lua",
                                }
                            )
                        end
                    end
                end
            end
        end

        --Picks a random projectile attack and gives it to entity in question
        local attackComp = EntityGetFirstComponentIncludingDisabled( enemy, "AIAttackComponent" )
        local projFile = pickrandomspellalt( pos_x, pos_y )
        if attackComp ~= nil then
            ComponentSetValue2( comp, "attack_ranged_entity_file", "data/entities/projectiles/" .. projFile .. ".xml" )
        end

        --1 in 120 chance to corrupt the sprite with a raw sprite png
        local spriteDone = false
        --if Random(1,120) == 1 then 
        if (Random(1,8400) <= settingCorruption) and (settingSprite == true) then
            local comp = EntityGetFirstComponentIncludingDisabled( enemy, "SpriteComponent" )
            if comp ~= nil then

                --Grabs random sprite file
                local spriteFile = pickrandomsprite( pos_x, pos_y )
                ComponentSetValue2( comp, "image_file", spriteFile .. ".png" )

                --Stops fish from being messed up on death
                if (EntityHasTag(enemy, "helpless_animal" ) == true) then
                    ComponentSetValue2( comp, "never_ragdollify_on_death", true )
                end
            end
            spriteDone = true
        end

        --33% chance to corrupt the sprite
        --if Random(1,3) == 1 and (spriteDone == false) then
        if (Random(1,100) <= settingCorruption) and (spriteDone == false)  then
            local comp = EntityGetFirstComponentIncludingDisabled( enemy, "SpriteComponent" )
            if comp ~= nil then

                --Grabs random sprite file
                local spriteFile = pickrandomsprite( pos_x, pos_y )
                ComponentSetValue2( comp, "image_file", spriteFile .. ".xml" )
            end

            --Stops fish from being messed up on death
            if (EntityHasTag(enemy, "helpless_animal" ) == true) then
                ComponentSetValue2( comp, "never_ragdollify_on_death", true )
            end
            spriteDone = true
        end

        --Updates ragdoll to match sprite
        --Keeps crashing, don't why, logger says nothing
        --[[
        if spriteDone == true then 
            local comp = EntityGetFirstComponentIncludingDisabled( enemy, "DamageModelComponent" )
            if comp ~= nil then
                local ragdollCheck = ComponentGetValue2( comp, "ragdoll_filenames_file")
                if (ragdollCheck ~= nil) or (ragdollCheck ~= 0) then
                ComponentSetValue2( comp, "ragdoll_filenames_file", "data/ragdolls/" .. spriteFile .. "/filenames.txt" )
                end
            end
        end
        ]]--



        --half of setting% chance to corrupt the audio
        if (Random(1,100) <= settingCorruption / 2) then
            local comp = EntityGetFirstComponentIncludingDisabled( enemy, "AudioComponent" )
            if comp ~= nil then

                --Grabs random audio file
                local audioFile = audioPool[Random(1,#audioPool)]
                ComponentSetValue2( comp, "event_root", audioFile )
            end
        end

        --Check it's a real enemy before giving it a elite perk effect
        --Check to see if pintpoint of light elite have visually obvious particle effects
        if (Random(1,25) == 1) and (settingCorruption >= 30) then
            local passiveGiven = Random(1,4) --Think up a list of perk ideas
            if passiveGiven == 1 then --Reflect Pin Point of life upon taking damage
                EntityAddComponent2(
                    enemy,
                    "LuaComponent",
                    {
                        execute_on_added = false,
                        script_damage_received="data/scripts/animals/wraith_glowing_damage.lua",
                        execute_every_n_frame = -1,
                        remove_after_executed = false,
                        execute_times=-1
                    }
                )
                EntityAddComponent2(
                    enemy,
                    "ParticleEmitterComponent",
                    {
                        emitted_material_name="spark_white",
                        --gravity.y=0.0
                        lifetime_min=0.4,
                        lifetime_max=0.7,
                        count_min=20,
                        count_max=30,
                        render_on_grid=true,
                        fade_based_on_lifetime=true,
                        --area_circle_radius.min=32
                        --area_circle_radius.max=72
                        cosmetic_force_create=false,
                        airflow_force=1.5,
                        airflow_time=1.9,
                        airflow_scale=0.15,
                        emission_interval_min_frames=1,
                        emission_interval_max_frames=1,
                        emit_cosmetic_particles=true,
                        draw_as_long=true,
                        x_vel_min=-1,
                        x_vel_max=1,
                        y_vel_min=-1,
                        y_vel_max=1,
                        is_emitting=true,
                        velocity_always_away_from_center=200
                    }
                )
            elseif passiveGiven == 2 then --50% chance to drop heart pickup
                EntityAddComponent2(
                    enemy,
                    "LuaComponent",
                    {
                        _tags="death_reward",
                        script_death="mods/creature_corruption/files/scripts/animals/centipede_death.lua",
                    }
                )
            elseif passiveGiven == 3 then --Shield
				local effect_id = EntityLoad( "mods/creature_corruption/files/entities/misc/shield.xml", pos_x, pos_y )
				EntityAddChild( enemy, effect_id )
            else --Projectile Stopping Aura
				local effect_id = EntityLoad( "mods/creature_corruption/files/entities/misc/projectile_stopper.xml", pos_x, pos_y )
				EntityAddChild( enemy, effect_id )
            end
        end

        EntityAddTag(enemy, "creature_corrupted" )
    end
end
