local projPool = {}
local spritePool = {}

local projPoolVanilla = {
    "acidburst",
    "acidshot",
    "acidshot_slow",
    "arrow",
    "bat",
    "bloomshot",
    "bomb",
    "bomb_cart",
    "bomb_holy",
    "cocktail",
    --"bomb_holy_giga",
    "bomb_small",
    "bossdragon",
    "bossdragon_ray",
    "buckshot",
    "bullet_poison",
    "chaos_polymorph",
    "chunk_of_soil",
    --"circle_acid_small", too laggy
    --"circle_blood_small",
    --"circle_lava_small",
    --"circle_water",
    "clusterbomb",
    "cocktail",
    "coward_bullet",
    "darkflame",
    "darkflame_stationary",
    "dotshot",
    "dotshot_strong",
    "egg_fire",
    "egg_monster",
    "egg_purple",
    "egg_red",
    "egg_slime",
    "egg_worm",
    "enlightened_laser_dark_wand",
    "enlightened_laser_elec_wand",
    "enlightened_laser_fire_wand",
    "enlightened_laser_light_wand",
    "explosion",
    "fire_trap",
    "fireball",
    "fireball_bigfirebug",
    "fireball_firebug", 
    "fireball_ghostly",
    "flamethrower",
    "freeze_circle",
    "fungus",
    "fungus_big_explosion",
    "fungus_explosion",
    "gasblob",
    "glitter_bomb",
    "glue",
    "glue_shot",
    "grenade_leader",
    "grenade_scavenger",
    "healshot",
    "healshot_safe_haven",
    "healshot_slow",
    "hiddenshot",
    "ice",
    "iceball",
    "icethrower",
    "invisshot",
    "laser_bouncy",
    "laser_lasergun",
    "laser_spear",
    "laser_turret",
    "laserbeam",
    "laserbeam_green",
    "lavashot",
    "meteor_green",
    "lightning",
    "lurkershot",
    "machinegun_bullet_roboguard_big",
    "machinegun_bullet_slow",
    "machinegun_bullet_slower",
    "machinegun_bullet_tank",
    "machinegun_bullet_tank_super",
    "megalaser_blue",
    "megalaser_blue_beam",
    "meteor_green",
    "mine",
    "mine_scavenger",
    "neutralizershot",
    "orb",
    "orb_blue",
    "orb_cursed",
    "orb_dark",
    "orb_expanding",
    "orb_green",
    "orb_green_accelerating",
    "orb_green_boss_dragon",
    "orb_green_spin",
    "orb_hearty",
    "orb_homing",
    "orb_neutral",
    "orb_pink",
    "orb_pink_big",
    "orb_pink_big_slow",
    "orb_pink_big_super",
    "orb_pink_big_super_shrapnel",
    "orb_pink_fast",
    "orb_pink_super",
    --"orb_poly",
    "orb_purple",
    "orb_swapper",
    "orb_tele",
    "orb_tiny",
    "orb_twitchy",
    "orb_weaken",
    "orb_wither",
    "orb_weaken",
    "orb_wither",
    "orbspawner",
    "orbspawner_blue",
    "orbspawner_green",
    "pebble",
    "pollen",
    "pollen_ball",
    --"polyorb",
    "present",
    "propane_tank",
    "radioactive_blob",
    "radioactive_blob_trail",
    "radioactive_liquid",
    "rain_gold",
    "remove_ground",
    "rocket_tank",
    "rocket_tiny",
    "rocket_tiny_roll",
    "sentryshot",
    "shieldshot",
    "shieldshot_small",
    "slimeblob",
    "slimetrail",
    "smalltentacle",
    "smalltentacle_melee",
    "sniperbullet",
    "soldiershot",
    "spit_trap",
    "summonshine",
    "tentacle",
    "thunder_trap",
    "thunderball",
    "thunderball_line",
    "thunderball_slow",
    "tnt",
    "wraith_glowing_laser",
    "deck/all_blackholes",
    "deck/all_deathcrosses",
    "deck/all_discs",
    --"deck/all_nukes",
    "deck/all_rockets",
    "deck/berserk_field",
    "deck/big_magic_shield_start",
    "deck/black_hole",
    "deck/black_hole_big",
    --"deck/black_hole_giga", Funny to see omega blackhole, but ultimately a bit too unfair, even for this mod
    "deck/bloodtentacle",
    "deck/bomb_detonator",
    "deck/bouncy_orb",
    "deck/bubbleshot",
    "deck/bullet",
    "deck/bullet_heavy",
    "deck/bullet_slow",
    "deck/chain_bolt",
    "deck/chainsaw",
    "deck/chaos_polymorph_field",
    "deck/charm_field",
    --"deck/cloud_acid",
    --"deck/cloud_blood",
    --"deck/cloud_water",
    "deck/crumbling_earth",
    "deck/disc_bullet",
    "deck/disc_bullet_big",
    "deck/disc_bullet_bigger",
    "deck/grenade",
    "deck/grenade_tier_2",
    "deck/grenade_tier_3",
    "deck/infestation",
    "deck/luminous_drill",
    "deck/regeneration_field",
    "deck/sausage",
    --"deck/sea_acid",
    --"deck/sea_alcohol",
    "deck/sea_water",
    --"deck/sea_lava",
    "deck/spitter",
    "deck/spitter_tier_2",
    "deck/spitter_tier_3",
    "deck/swarm_wasp",
    "deck/swarm_fly",
    "deck/swarm_firebug",
    "deck/touch_gold",
    "deck/worm_shot",
    "deck/megalaser",
    "deck/light_bullet",
    "deck/spiral_shot",
    "deck/spore_pod",
}


local spritePoolVanilla = {
    "acidshooter",
    "acidshooter_weak",
    "alchemist",
    "ant",
    "assassin",
    "barfer",
    "basebot_hidden",
    "basebot_neutralizer",
    "basebot_sentry",
    "basebot_soldier",
    "bat",
    "bigbat",
    "bigfirebug",
    "bigzombie",
    "bigzombiehead",
    "bigzombietorso",
    "blob",
    "bloom",
    "chest_mimic",
    "coward",
    "crystal",
    --"darkghost",
    "darkghost_skull",
    "deer",
    "dragon_head",
    "dragon_body",
    "dragon_tail",
    "drone",
    "drone_shield",
    "duck",
    "elk",
    "endworm_head",
    "endworm_middle",
    "endworm_tail",
    "enlightened_alchemist",
    "ethereal_being",
    "failed_alchemist",
    "failed_alchemist_b",
    "firebug",
    "firemage",
    "firemage_weak",
    "fireskull",
    "fish_01",
    "fish_02",
    "flamer",
    "fly",
    "friend",
    "frog",
    "frog_big",
    "fungus",
    "fungus_big",
    "fungus_giga",
    "fungus_tiny",
    "fungus_tiny_b",
    "gazer",
    "ghost",
    "ghoul",
    "giant",
    "giantshooter",
    "giantshooter_weak",
    "goblin_bomb",
    "greed_ghost",
    "homunculus",
    "homunculus_dark",
    "homunculus_fire",
    "homunculus_heal",
    "homunculus_laser",
    "icer",
    "iceskull",
    "lasershooter",
    "longleg",
    "lurker",
    "maggot",
    "maggot_tiny_head",
    "maggot_tiny_body",
    "maggot_tiny_tail",
    "mine",
    "miner",
    "miner_chef",
    "miner_fire",
    "miner_santa",
    "miner_weak",
    "miniblob",
    "missilecrab",
    "monk",
    "monk_hand",
    "necrobot",
    "necrobot_super",
    "necromancer",
    "necromancer_shop",
    "necromancer_super",
    "peasant",
    "pebble",
    "phantom_a",
    "phantom_b",
    "plague_rat",
    "player",
    "playerghost",
    "rat",
    "roboguard",
    "roboguard_big",
    "scavenger_clusterbomb",
    "scavenger_glue",
    "scavenger_grenade",
    "scavenger_heal",
    "scavenger_invis",
    "scavenger_leader",
    "scavenger_mine",
    "scavenger_poison",
    "scavenger_shield",
    "scavenger_smg",
    "scorpion",
    "shaman",
    "sheep",
    "sheep_bat",
    "sheep_fly",
    "shooterflower",
    "shotgunner",
    "shotgunner_weak",
    "skullfly",
    "skullmage",
    "skullrat",
    "skygazer",
    "slimeshooter",
    "slimeshooter_weak",
    "sniper",
    "spearbot",
    "spitmonster",
    "statue",
    "tank",
    "tank_gun",
    "tank_rocket",
    "tank_rocket_gun",
    "tank_super",
    "tank_super_gun",
    "tentacler",
    "tentacler_small",
    "thundermage",
    "thundermage_big",
    "thunderskull",
    "turret",
    "ultimate_killer",
    "wizard_dark",
    "wizard_hearty",
    "wizard_neutral",
    "wizard_poly",
    "wizard_returner",
    "wizard_swapper",
    "wizard_tele",
    "wizard_twitchy",
    "wizard_weaken",
    "wizard_wither",
    "wolf",
    "worm_big_head",
    "worm_big_body",
    "worm_big_tail",
    "worm_head",
    "worm_body",
    "worm_tail",
    "worm_skull_head",
    "worm_skull_body",
    "worm_skull_tail",
    "worm_tiny_head",
    "worm_tiny_body",
    "worm_tiny_tail",
    "wraith",
    "wraith_glowing",
    "wraith_storm",
    "zombie",
    "zombie_weak",
}






local mocreepProj = {
    "aquamine_npc",
    "aquamine_npc_homing",
    --"basebot_speedershot",
    --"beam_holy_orb_warning",
    "beam_holy_warning",
    --"blob_ball",
    --"bomb_giga_npc",
    "boss_music_delayed_attack_start",
    "circle_divine_liquid",
    "coldshot_BoC",
    "coldshot_BoC_weak",
    --"darkflame_tripleshot",
    "disc_bullet_thrower",
    --"enlightened_heal_test_proj",
    --"enlightened_heal_test_wand",
    --"enlightened_laser_ice_wand",
    --"enlightened_laser_iceball",
    --"fungus_smoke_maker",
    "fungus_tiny_explosion",
    --"healshot_ailment",
    "imp_slow_proj",
    "lavashot_BoC",
    "lavashot_BoC_weak",
    "magic_arrow_big",
    "magic_arrow_big_nolua",
    "mass_status_haste_effect",
    "mass_status_mattereater_effect",
    --"materia_conversion_explosion", basically a nuke
    "meteor_npc",
    "meteor_npc_superhoming",
    "meteor_npc_superhoming_setup",
    --"miniblob_throw",
    "missile_ATG",
    "mist_poison",
    "mist_water",
    "musical_attack_healing",
    "musical_attack_shotgun_homing",
    "musical_attack_shotgun_small",
    "musical_attack_shotgun_small_red",
    "orb_ambrosia",
    "orb_berserk",
    "orb_blue_big_explosive_nolla",
    "orb_cursed_shotgun",
    "orb_cursed_thrower",
    "orb_devil",
    "orb_duck",
    "orb_explosive",
    "orb_fairy",
    "orb_green_triangle",
    "orb_holy_shotgun",
    "orb_holy_shotgun_small",
    "orb_holy_shotgun_small_blob",
    "orb_holy_shotgun_small_blob_nightmare",
    "orb_magicslime",
    "orb_manadrain",
    "orb_micro_blackhole",
    "orb_pink_big_explosive_nolla",
    --"orb_poly_chaotic_redirect_start",
    "orb_poly_chaotic_vacuum",
    "orb_psychotic",
    "orb_psychotic_nodmg",
    "orb_red_big_explosive_nolla",
    "orb_unstable_transmutation",
    "pentashot",
    "pentashot_nolua",
    "pollen_monster",
    "polyshot_BoC",
    "psychotic_illusion_summoner",
    "railcannon_delayed_attack_warning",
    "railcannon_delayed_attack_end",
    "railgunner_delayed_homing",
    "robot_gunner_projectile",
    --"robot_stand_portal",
    --"robot_stand_portal_prefx",
    "robotic_gunner_laser_attack_end",
    "robotic_gunner_laser_attack_warning",
    "robotic_gunner_orb",
    "robotic_gunner_portal",
    --"rocket_drillcharge",
    "rocket_push",
    "slimeblob_gluey",
    --"slimeblob_mud",
    --"soldiershot_weak",
    --"spit",
    "star_shotgun",
    "star_shotgun_esoteric",
    "star_shotgun_nolua",
    "star_shotgun_suck",
    "teleport_projectile_npc",
    "tentacle_green",
    "tentacle_portal_npc",
    "tentacle_portal_orb",
    "touch_gold_npc",
    "toxicshot",
    "toxicshot_homing",
    "transmute_acid",
    "transmute_cursed_liquid",
    "transmute_fungus",
    "transmute_lava",
    "transmute_lively_concoction",
    "transmute_poison",
    "transmute_polymorph",
    "transmute_precursor",
    "transmute_teleport",
    "waterball",
    "deck/aquamine",
    "deck/bomb_giga",
    "deck/field_reverberation",
    "deck/mass_status_drunk",
    "deck/mass_status_fire",
    --"deck/mass_status_polymorph",
    "deck/mass_status_urine",
    "deck/mass_status_wet",
    "deck/musical_delayed_attack_end",
    "deck/orb_holy_shotgun",
    "deck/orb_holy_shotgun_cursed",
    "deck/rat_bite",
    "deck/rat_bite_crit",
    "deck/spells_to_cats",
    "deck/summon_worm_big",
    --"deck/targetter",
}




local mocreepSprite = {
    "alchemist_warper",
    --"basebot_speeder",
    "bat_psychic",
    "blindgazer",
    "blob_big",
    "blob_huge",
    "blob_titan",
    "Bone_worm",
    "Bone_worm_red",
    "Bone_worm_tail",
    "bubble_liquid_acid",
    "bubble_liquid_alchemicprecursor",
    "bubble_liquid_ambrosia",
    "bubble_liquid_blood",
    "bubble_liquid_cursed_liquid",
    "bubble_liquid_deceleratium",
    "bubble_liquid_freezing_liquid",
    "bubble_liquid_healthium",
    "bubble_liquid_pandorium",
    "bubble_liquid_pandoriumunstable",
    "bubble_liquid_sliceliquid",
    "bubble_liquid_stophittingyourself",
    "bubble_liquid_voidliquid",
    "bubble_liquid_water",
    "cat",
    "cat_black",
    "cat_golden",
    "cat_skateboard",
    "cat_white",
    "cat_wizard",
    "coldgazer_greater",
    "devourer_ghost",
    "devourer_ghost_minion",
    "devourer_magic",
    "devourer_mana",
    "drone_mini",
    --"drone_status_ailment",
    "esoteric_being",
    --"esoteric_being_alt",
    "fairy_big",
    "fairy_big_discord",
    "fairy_big_esoteric",
    "fairy_gold",
    "fairy_ylw",
    "firemage_big",
    "forsaken_eye",
    "forsaken_eye_symbol",
    --"fungus_smoke",
    "gazer_greater",
    "gazer_robot",
    "goo_slug",
    "goo_slug_vault",
    "hisii_clown",
    "hisii_engineer",
    --"hisii_giga_bomb",
    "hisii_hobo",
    "hisii_hobo_rich",
    "hisii_minecart",
    "hisii_minecart_shades",
    "hisii_minecart_smissmass",
    "hisii_minecart_tnt",
    "hisii_minecart_tnt_santa",
    "hisii_minecart_weak",
    "hisii_minecart_weak_smissmass",
    "hisii_minecart_worse",
    "hisii_minecart_worse_smissmass",
    --"hisii_minecart_worse_tnt",
    --"hisii_minecart_worse_weak",
    --"hisii_minecart_worse_weak_smissmass",
    "hisii_railgun",
    "hisii_rocketshotgun",
    "longleg_pillar",
    "longleg_pillar_two",
    "mimic_explosive_box",
    --"mudman_friendly",
    "poisonmushroom",
    "poring",
    "poring_devil",
    "poring_halloween",
    "poring_halloween_weak",
    "poring_lukki",
    "poring_magic",
    "poring_sand",
    "poring_sandcave",
    "poring_santa",
    "poring_santa_weak",
    "poring_swamp",
    "poring_weak",
    "rat_birthday",
    "sentry",
    "shaman_greater",
    "skygazer_greater",
    "star_child",
    "tank_flame",
    "tank_flame_gun",
    "tentacler_big",
    "tree_tall",
    "triangle_gem",
    "turret_tesla",
    "ultralisk_fish",
    "whisp",
    "wizard_ambrosia",
    "wizard_copeseethmald",
    "wizard_duck",
    "wizard_explosive",
    "wizard_jackofalltrades",
    "wizard_manaeater",
    "wizard_transmutation",
    "wizard_z_poly_miniboss",
    --"wraith_returner",
    "wraith_weirdo",
    "zzz_sussy",
    "summons/enchanted_duck",
    "summons/fungus_minion",
    "angel/angel",
    "ceiling/ceiling_barnacle",
    "ceiling/ceiling_fungus",
    "lukki/lukki_fungus",
    "lukki/lukki_fungus_dirty",
    "ghost/boss_musical_ghost",
    "ghost/ghost_bow",
    "ghost/musical_being",
    "ghost/silent",
    "toxic_worm/toxic_worm_head",
    "toxic_worm/toxic_worm_body_1",
    "toxic_worm/toxic_worm_body_2",
    "toxic_worm/toxic_worm_body_3",
    "toxic_worm/toxic_worm_body_4",
    "toxic_worm/toxic_worm_tail",
    "toxic_worm/toxic_worm_minion_head",
    "toxic_worm/toxic_worm_minion_body",
    "toxic_worm/toxic_worm_minion_tail",
    "worms/giant_centipede_head",
    "worms/giant_centipede_body_1",
    "worms/giant_centipede_tail",
    --"fire_lukki/fire_lukki",
}




local nePoolProj = {
    "acid_explosion",
    "alcohol_explosion",
    "alien_shot",
    "aquatitan_wave",
    "arrow_rain",
    "arrow2",
    "banana",
    "blob_ceiling",
    "blood_explosion",
    "blood_spear",
    "blood_teddy_shot",
    "bloomshot_toxic",
    "blue_fire_explosion",
    "blue_fire_shot",
    "bomb_radioactivegas",
    "booze",
    "boss_tnt",
    "cage",
    "cage_spawner",
    "cargobot_shot",
    "cobra_shot",
    "commander_clusterbomb",
    "commandershot",
    "compressor_shot_child",
    "compressor_shot_main",
    "compressor_shot_main_homing",
    "conduit_explosion",
    "convert_static_to_liquid",
    "corrupt_alchemist_rocket",
    "cyborg_rocket",
    "darkflame_homing",
    "darkflame_nocollide",
    "disc_fire",
    "dragon_ice_shot",
    "drake_snake",
    "drone_tail",
    "eggshot",
    "electric_bullet",
    "electricskull",
    "electrocute_entity",
    "electrocute_entity_weaker",
    "ent_fire",
    "ent_rock",
    "eradicator_laser_spawner",
    "eye",
    "eye_shot",
    "eye_shot_hell",
    "feather",
    "feather2",
    "feather3",
    "fire_crawler_blob",
    "fire_crawler_flamethrower",
    "fire_spawner",
    "fireball_bird",
    "fireball_black",
    "fireball_ghostly_big",
    "fireball_giantfirebug",
    "firepillar",
    "firepillar_part",
    "floating_eye_shot",
    "flower_fire",
    "freeze_puke",
    "gas_trail",
    "gazer_laser_projectile",
    "gazer_laser_projectile_spawner",
    "gazershot",
    "gazershot2",
    "ghuu_shot",
    "giant_alt_shot_spawner",
    "golden_blob_trail",
    "golem_attack",
    "golem_attack_earthquake",
    "green_fire_shot",
    "hairling_laser_child",
    "harpy_laser",
    "hydra_poisonshot",
    "iceball_big",
    "iceskull",
    "icicle",
    "icicle_shot",
    "laser_eye",
    "lava",
    "longleg",
    "longleg_gold",
    "medusa_projectile",
    "nova_laser_projectile_main",
    "mwyah_tentacle_main",
    "nautilus_laserbeam",
    "nautilustentacle",
    "nova_laser_projectile_main",
    "nova_phat_laser",
    "ominous_shot",
    "ooion_projectile",
    "orb_blue_big",
    "orb_blue_fast",
    "orb_creep",
    "orb_earthquake",
    "orb_hate",
    "orb_love",
    "orb_love_hate",
    "orb_mist_blood",
    "orb_twin",
    "phantom_boss_orb",
    "phat_laser",
    "phat_laser_horizontal",
    "plasma_spawner",
    "plasmaspawner",
    "poison_immunity_shot",
    "power_orb",
    "radioactive_blob_jungle_worm",
    "radioactive_blob_slime_turret",
    "radioactive_shot",
    "random_summonshine",
    "red_fire_shot",
    "robot_disc",
    "rocket_tank_boss",
    "scavenger_laser",
    "shuriken",
    "smart_bullet",
    "smoke_bomb",
    "star_ring",
    "tentacle_khulu",
    "thou_laser_spawner",
    "tongue_green",
    "tongue_lava",
    "very_small_blob",
    "web_ball",
    "wraith_laser_spawner",
    "yellow_shot",
}

local nePoolSprite = {
    "alchaos",
    "alien",
    "alligator_temple_body",
    "alligator_temple_head",
    "altar",
    "angler_body",
    "aquatitan",
    "aquatitan_small",
    "archer",
    "archer_old",
    "axeman",
    "axeman_old",
    "babon",
    "bigfly",
    "bigfly_old",
    "bird",
    "blood_teddy",
    "bloodmage_greater",
    "bloodskullsprite",
    "bloom_ceiling",
    "bluemancer",
    "book",
    "boss_wraith",
    "bot",
    "bouncer",
    "bouncer_alt",
    "camel",
    "cargobot",
    "ceilingflower",
    "chaoticpolyshooter",
    "chest_great_mimic",
    "cobra",
    "conduit",
    "copter",
    "crawler",
    "creeper",
    "creeper_alt",
    "cryogen",
    "cryogen_gun",
    "darkghost2",
    "desert_skull_eye",
    "desert_skull_eye_bg",
    "desert_skull_eye_old",
    "desert_skull_eye_pupil",
    "desulitor",
    "doom_bringer",
    "dragon_ice_head",
    "draghoul",
    "driller",
    "dripper",
    "drone_beam",
    "earthmage",
    "earthskull",
    "eldari_big",
    "electricskull",
    "electrobot",
    "enigma",
    "ent",
    "eradicator",
    "eye",
    "eye_bat",
    "face_worm_head",
    "face_worm_body",
    "face_worm_tail",
    "fallen_alchemist",
    "fish_03",
    "fish_04",
    "flesh_monster",
    "flopper_son_ice",
    "forgotten_alchemist",
    "fungus_spore",
    "fungus_swamp",
    "fury1",
    "fury2",
    "fury3",
    "gazer_laser",
    "gazer_necromancer",
    "ghostling",
    "ghust",
    "ghuu",
    "giant_alt",
    "giant_alt_head",
    "giant_old",
    "giant_squid",
    "giant_temple",
    "god",
    "golem",
    "goomonster",
    "goomonster_giant",
    "hybrid",
    "hydra_head1",
    "hydra_head2",
    "hydra_head3",
    "icemage_big",
    "icemage2",
    "icicle",
    "icicle_king",
    --"igu_alt",
    "imp",
    "jellyfish",
    "jungle_worm_big_head",
    "jungle_worm_big_body",
    "jungle_worm_big_tail",
    "khulu",
    "knight",
    "knight_heart",
    "lempo",
    "lost_soul",
    "lost_soul_big",
    "lukki_blue",
    "lukki_ominous",
    "lukki_red",
    "lukki_weird",
    "lurker2",
    "mammoth",
    "mammoth_baby",
    "manus",
    "manus_hand",
    "medusa",
    "menhir",
    "moal",
    "monkey",
    "miner_boss",
    "mwyah_face_animation",
    "mwyah",
    "nautilus",
    "necromancer_polymorph",
    "ooion",
    "polyp_gas",
    "polyshooter",
    "scavenger_king",
    "seamonster_head",
    "seamonster_body",
    "seamonster_tail",
    "serpentor",
    "shapeshifter",
    "shiva",
    "shotgunner_b",
    "singularitor",
    "skeleton",
    "skeleton_4th_july",
    "skeleton_carnival",
    "skeleton_champagne",
    "skeleton_diwalli",
    "skeleton_mariachi_harp2",
    "skeleton_mariachi_maraca2",
    "skull_abomination",
    "slime_turret",
    "slimeshooter_golden",
    "slimeshooter_mega",
    "sorceress",
    "spooky_ghost",
    "spider",
    "spider_old",
}






--Adds vanilla files to proj/sprite pool
for i,proj in ipairs(projPoolVanilla) do
    table.insert(projPool, "data/entities/projectiles/" .. proj)
end

for i,sprite in ipairs(spritePoolVanilla) do
    table.insert(spritePool, "data/enemies_gfx/" .. sprite)
end



--Adds More Creeps & Weirdos projectiles & sprites to their respective pools
if ModIsEnabled("Mo_Creeps") then
    for i,proj in ipairs(mocreepProj) do
        table.insert(projPool, "mods/mo_creeps/files/entities/projectiles/" .. proj)
    end

    for i,sprite in ipairs(mocreepSprite) do
        table.insert(spritePool, "mods/mo_creeps/files/enemies_gfx/" .. sprite)
    end
end




--Adds new enemy files to proj/sprite pool
--[[
]]--
if ModIsEnabled("new_enemies") then
    for i,proj in ipairs(nePoolProj) do
        table.insert(projPool, "data/entities/projectiles/" .. proj)
    end

    for i,sprite in ipairs(nePoolSprite) do
        table.insert(spritePool, "data/enemies_gfx/" .. sprite)
    end
end



--Functions for corruption update file to pick a random file
function pickrandomspell( seed_x, seed_y )
    SetRandomSeed(seed_x + seed_y, seed_x * seed_y)
    local projFile = projPool[Random(1,#projPool)]
    return projFile
end

function pickrandomspellalt( seed_x, seed_y )
    SetRandomSeed(seed_x * seed_y, seed_x + 7 + seed_y)
    local projFile = projPool[Random(1,#projPool)]
    return projFile
end


function pickrandomsprite( seed_x, seed_y )
    SetRandomSeed(seed_x + seed_y, seed_x * seed_y)
    local spriteFile = spritePool[Random(1,#spritePool)]
    return spriteFile
end