dofile("data/scripts/lib/utilities.lua")



--Adds Corruption check to player
function OnPlayerSpawned( player_entity )
    EntityAddComponent2(
        player_entity,
        "LuaComponent",
        {
            execute_on_added = false,
            script_source_file="mods/creature_corruption/files/scripts/player_corruption_update.lua",
            execute_every_n_frame = 120,
            remove_after_executed = false,
            execute_times=-1
        }
    )

    if ModSettingGet( "creature_corruption.failsafe" ) ~= false then
        EntityAddComponent2(
            player_entity,
            "LuaComponent",
            {
                execute_on_added = false,
                script_source_file="mods/creature_corruption/files/scripts/player_proj_failsafe.lua",
                execute_every_n_frame = ModSettingGet( "creature_corruption.failsafe_frequency" ),
                remove_after_executed = false,
                execute_times=-1
            }
        )
    end
end

-- Corrupts Boss Attacks
-- Dragon
local nxml = dofile_once("mods/creature_corruption/lib/nxml.lua")
local content = ModTextFileGetContent("data/entities/animals/boss_dragon.xml")
local xml = nxml.parse(content)
xml:add_child(nxml.parse([[
    <LuaComponent
      script_source_file="mods/creature_corruption/files/scripts/animals/boss_dragon_init.lua"
      execute_every_n_frame="2"
      execute_times="1"
      remove_after_executed="1"
      >
    </LuaComponent>
  ]]))
ModTextFileSetContent("data/entities/animals/boss_dragon.xml", tostring(xml))

-- Master of Masters
local nxml = dofile_once("mods/creature_corruption/lib/nxml.lua")
local content = ModTextFileGetContent("data/entities/animals/boss_wizard/boss_wizard.xml")
local xml = nxml.parse(content)
xml:add_child(nxml.parse([[
    <LuaComponent
      script_source_file="mods/creature_corruption/files/scripts/animals/boss_wizard_init.lua"
      execute_every_n_frame="2"
      execute_times="1"
      remove_after_executed="1"
      >
    </LuaComponent>
  ]]))
ModTextFileSetContent("data/entities/animals/boss_wizard/boss_wizard.xml", tostring(xml))




--Mo Creeps Bosses
if ModIsEnabled("Mo_Creeps") then
  local content = ModTextFileGetContent("data/entities/animals/boss_toxic_worm/boss_toxic_worm.xml")
  local xml = nxml.parse(content)
  xml:add_child(nxml.parse([[
      <LuaComponent
        script_source_file="mods/creature_corruption/files/scripts/animals/boss_dragon_init.lua"
        execute_every_n_frame="2"
        execute_times="1"
        remove_after_executed="1"
        >
      </LuaComponent>
    ]]))
  ModTextFileSetContent("data/entities/animals/boss_toxic_worm/boss_toxic_worm.xml", tostring(xml))
end
