dofile("data/scripts/lib/mod_settings.lua")

function mod_setting_change_callback( mod_id, gui, in_main_menu, setting, old_value, new_value  )
	print( tostring(new_value) )
end

local mod_id = "creature_corruption"
mod_settings_version = 1
mod_settings = 
{
  {
    id = "corruption_level",
    ui_name = "Corruption Level",
    ui_description = "How corrupt do you want the game?",
    value_default = 33,
    value_min = 0,
    value_max = 100,
    value_display_multiplier = 1,
    value_display_formatting = " $0% Corruption",
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "spritesheet",
    ui_name = "Do sprite sheets appear?",
    ui_description = "Do sprite sheets rarely appear ingame to replace normal sprites?",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "failsafe",
    ui_name = "Projectile Failsafe",
    ui_description = "Is a projectile failsafe enabled? \n \nIf this is enabled, when over 200 projectiles are on the screen, \nall projectiles are voided to attempt to clear lag. \nThis is enabled by default but can be disabled. \nMay cause more lag on lower end machines than it saves, \nbut at that point you're probably making a mistake playing this mod if i'm being honest, but, hey, it's your machine, your choice!",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME_RESTART,
  },
  {
    id = "failsafe_amount",
    ui_name = "Failsafe cut off",
    ui_description = "How many projectiles can be loaded at once before the failsafe deletes them? \nDefault value is 200.",
    value_default = 200,
    value_min = 50,
    value_max = 400,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "failsafe_frequency",
    ui_name = "Failsafe frequency",
    ui_description = "How often does the failsafe check? This is how many frames is between each check. \n60 frames = 1 second. \nDefault value is 60 frames. \nThis will only update at the start of a new run.",
    value_default = 60,
    value_min = 10,
    value_max = 100,
    scope = MOD_SETTING_SCOPE_NEW_GAME,
  },
}

function ModSettingsUpdate( init_scope )
	local old_version = mod_settings_get_version( mod_id )
	mod_settings_update( mod_id, mod_settings, init_scope )
end

function ModSettingsGuiCount()
	return mod_settings_gui_count( mod_id, mod_settings )
end

function ModSettingsGui( gui, in_main_menu )
	mod_settings_gui( mod_id, mod_settings, gui, in_main_menu )
end
